﻿using System;
using System.Linq;
using ThinkGeo.MapSuite;
using ThinkGeo.MapSuite.Drawing;
using ThinkGeo.MapSuite.Layers;
using ThinkGeo.MapSuite.Shapes;
using ThinkGeo.MapSuite.Styles;
using ThinkGeo.MapSuite.WebForms;

namespace StateServerSessionTest
{
    public partial class WebForm1 : System.Web.UI.Page
    {
        protected void Page_Load(object sender, EventArgs e)
        {
            try
            {
                if (!IsPostBack)
                {
                    Map1.MapUnit = GeographyUnit.DecimalDegree;

                    LayerOverlay layerOverlay = new LayerOverlay("layerOverlay");
                    InMemoryFeatureLayer imf = new InMemoryFeatureLayer();
                    imf.ZoomLevelSet.ZoomLevel01.DefaultAreaStyle = AreaStyles.Country1;
                    imf.ZoomLevelSet.ZoomLevel01.ApplyUntilZoomLevel = ApplyUntilZoomLevel.Level20;
                    imf.InternalFeatures.Add(new Feature(new RectangleShape(-100, 50, -80, 30)));
                    layerOverlay.Layers.Add(imf);
                    Map1.CustomOverlays.Add(layerOverlay);
                    Map1.CurrentExtent = new RectangleShape(-178.215027, 71.406647, -66.969849, 18.924782);
                }
            }
            catch (Exception ex)
            {

            }
        }

        private TextStyle GetHaloLabelRender(float FontWidth, string strRenderField, GeoColor TextColor, bool blnOnTop = false)
        {
            if (blnOnTop == true)
            {
                return TextStyles.CreateSimpleTextStyle(strRenderField, "Arial", FontWidth, DrawingFontStyles.Bold, TextColor, GeoColor.StandardColors.White, 3, 10, 10);
            }
            else
            {
                return TextStyles.CreateSimpleTextStyle(strRenderField, "Arial", FontWidth, DrawingFontStyles.Bold, TextColor, GeoColor.StandardColors.White, 3, -10, -10);
            }
        }

        protected void Button_Click(object sender, EventArgs e)
        {
            LayerOverlay layerOverlay = (LayerOverlay)Map1.CustomOverlays.First(o => o.Id.Equals("layerOverlay"));
            ShapeFileFeatureLayer shapeFileLayer = new ShapeFileFeatureLayer(MapPath(@"App_Data\states.shp"), MapPath(@"App_Data\states.idx"), GeoFileReadWriteMode.Read, System.Text.Encoding.Default);
            ZoomLevel objZoom = shapeFileLayer.ZoomLevelSet.ZoomLevel01;
            objZoom.ApplyUntilZoomLevel = ApplyUntilZoomLevel.Level20;
            AreaStyle objStyle = default(AreaStyle);
            objStyle = new AreaStyle(new GeoSolidBrush(GeoColor.FromArgb(100, GeoColor.StandardColors.DarkBlue)));
            objZoom.CustomStyles.Add(objStyle);
            objZoom.CustomStyles.Add(GetHaloLabelRender(6.5F, "FULLNAME", GeoColor.StandardColors.DarkBlue));
            shapeFileLayer.ZoomLevelSet.CustomZoomLevels.Add(objZoom);
            layerOverlay.Layers.Add(shapeFileLayer);


            //Adds a FeatureOverlay Point that represents the Highlight Overlay
            PointShape objPoint = new PointShape(-100, 45);
            GeoColor objPointColor = new GeoColor(255, 0, 0);
            PointStyle objPointStyle = new PointStyle((PointSymbolType)0, new GeoSolidBrush(objPointColor), 6);
            Feature pointmap = new Feature(objPoint);
            Map1.HighlightOverlay.Features.Add(pointmap);
        }
    }
}